;
$DEBUG
$DATE (03.03.2008)
$TITLE (Blink-3.a51)
$PAGELENGTH(56)
$PAGEWIDTH(150)
$XREF
$NOLIST
$NOMOD51
$INCLUDE(89S8252.MCU)

$LIST
;

;********************************************************************************************************
; Testprogramm fr Port 1 ber Timer
; LEDs an Port 1 bilden Lauflicht: eine an, hin und her
; J. Rathlev, Okt. 2004
;********************************************************************************************************

      NAME      Blink_3

;********************************************************************************************************
; Konstanten
; ==========

CODEMEM EQU     8000H

; Portanschlssse fr LEDs                                
Port    EQU     P1      

; Berechnung des Zhlerwertes:
;     N = 65536 - T/s * f/MHz / 12  

; f(Takt) = 24 MHz: 10 ms ==> 45536
; f(Takt) = 22,1184 MHz: 10 ms ==> 47104
 
 
TIMCNT  EQU     47104   ; Zhlerwert fr 10 ms bei 22,1184 MHz

T500MS  EQU     50      ; Anzahl der 10ms Takte fr 500 ms

;********************************************************************************************************
; RAM-Daten
; =========

        DSEG    AT      30H

TCOUNT: DS      1               ; Zhler fr 10ms Takt

        BSEG    AT      0H

Left:   DBIT    1

;********************************************************************************************************
; Programmstart

        CSEG    AT      CODEMEM

        LJMP    Start

        ORG     CODEMEM+Timer0

        LJMP    T0IRQ


;********************************************************************************************************
; Timer 0 Interrupt

        ORG     CODEMEM+30H

USING   2                       ; Registerbank 2 verwenden

T0IRQ:  PUSH    PSW
        MOV     PSW,#010H      ; Registerbank 2 einschalten

        MOV     TH0,#HIGH(TIMCNT)
        MOV     TL0,#LOW(TIMCNT)
        DJNZ    TCOUNT,T0RET

        PUSH    ACC
        MOV     A,Port      
        JNB     Left,T0Irq1
        JNB     ACC.7,T0Irq3
        RL      A
        JMP     T0Irq2
       
T0Irq1: JNB     ACC.0,T0Irq3
        RR      A
        JMP     T0Irq2        

T0Irq3: CPL     Left

T0Irq2:        
        MOV     Port,A
        POP     ACC
        MOV     TCOUNT,#T500MS

T0RET:  POP     PSW             ; Flags wiederherstellen 
        RETI
   
USING   0                       ; Registerbank 0 verwenden


;********************************************************************************************************
; Timer 0 initialisieren, Interrupts freischalten

INIT:   MOV     A,TMOD      
        ANL     A,#0F0H         ; Ausmaskieren von Timer 0 (Bit 0..3)
        ORL     A,#01H          ; Setze Mode 1, int. Zhltakt
        MOV     TMOD,A
        MOV     TH0,#HIGH(TIMCNT) ; Anfangswert fr 10 ms
        MOV     TL0,#LOW(TIMCNT)
        CLR     TF0
        MOV     TCOUNT,#T500MS  ; Wert fr 0,5 s
        SETB    TR0             ; Starte Timer
        SETB    ET0             ; Enable Timer-Interrupt
        SETB    EA              ; Enable Global-Interrupt
        RET


;********************************************************************************************************
; Hauptprogramm

Start:  MOV     SP,#STACKSTART
        CALL    Init            ; initialisieren
        MOV     Port,#0FEH
        SETB    Left
LOOP:   SJMP    LOOP            ; Endlosschleife


;********************************************************************************************************
        DSEG

STACKSTART:
        DS      1               ; Anfang des Stacks: Rest des internen Speichers

END

